local SayKarmaEvent = CreateFrame("Frame");
SayKarmaEvent.playername = UnitName("player");

-- ==================================================
--					EVENT
-- ==================================================
SayKarmaEvent:SetScript("OnEvent", function(_,_,_,event, _,_,sourceName, _,_,_,destName, _,_,spellId)
        -- is SayKarma enable ? just a fast way to disable SayKarma without to reload everything
        -- yes: we check the events
        -- no: we do nothing
        if (SayKarmaPrefs['SayKarmaEnable'] == "yes") then
            -- DeathKnight =====================================================
            if (SayKarmaPrefs['DeathKnightEnable'] == "yes") then
                -- Mind Freeze
                if ((spellId == 47528)
                    and (destName == SayKarmaEvent.playername)
                    and (event == "SPELL_AURA_APPLIED" or event == "SPELL_AURA_REFRESH"))
                then
                    local splink = GetSpellLink(47528);
                    SendChatMessage("{rt8} Silenced by this dk -> "..(sourceName or "(unknown)") .." with: ".. splink .." ! {rt8}","SAY");
                end

                -- Strangulation/Asphyxiate
                if ((spellId == 108194)
                    and (destName == SayKarmaEvent.playername)
                    and (event == "SPELL_AURA_APPLIED" or event == "SPELL_AURA_REFRESH"))
                then
                    local splink = GetSpellLink(108194);
                    SendChatMessage("{rt8} Stunned by this dk "..(sourceName or "(unknown)") .." with -> ".. splink .." ! {rt8}","SAY");
                end
            end
            -- End DeathKnight =================================================

            -- Druid ===========================================================
            if (SayKarmaPrefs['DruidEnable'] == "yes") then
                -- Cyclone
                if ((spellId == 33786)
                    and (destName == SayKarmaEvent.playername)
                    and (event == "SPELL_AURA_APPLIED" or event == "SPELL_AURA_REFRESH"))
                then
                    local splink = GetSpellLink(33786);
                    SendChatMessage("{rt8} " .. splink .. " on me, by this druid -> "..(sourceName or "(unknown)") .." ! {rt8}","SAY");
                end
            end
            -- End Druid =======================================================

            -- Hunter ==========================================================
            if (SayKarmaPrefs['HunterEnable'] == "yes") then
                -- Counter Shot
                if ((spellId == 147362)
                    and (destName == SayKarmaEvent.playername)
                    and (event == "SPELL_AURA_APPLIED" or event == "SPELL_AURA_REFRESH"))
                then
                    local splink = GetSpellLink(147362);
                    SendChatMessage("{rt8} Silenced by this hunt -> "..(sourceName or "(unknown)") .." with: ".. splink .." ! {rt8}","SAY");
                end

                -- Freezing trap
                if ((spellId == 3355)
                    and (destName == SayKarmaEvent.playername)
                    and (event == "SPELL_AURA_APPLIED" or event == "SPELL_AURA_REFRESH"))
                then
                    local splink = GetSpellLink(3355);
                    SendChatMessage("{rt8} ".. splink .." on me, by this hunt -> "..(sourceName or "(unknown)") .." ! {rt8}","SAY");
                end
            end
            -- End Hunter ======================================================

            -- Mage ============================================================
            if (SayKarmaPrefs['MageEnable'] == "yes") then
                -- Counter spell
                if ((spellId == 2139)
                    and (destName == SayKarmaEvent.playername)
                    and (event == "SPELL_AURA_APPLIED" or event == "SPELL_AURA_REFRESH"))
                then
                    local splink = GetSpellLink(2139);
                    SendChatMessage("{rt8} Silenced by this mage -> "..(sourceName or "(unknown)") .." with: ".. splink .." ! {rt8}","SAY");
                end

                -- Sheep
                if ((spellId == 118)
                    and (destName == SayKarmaEvent.playername)
                    and (event == "SPELL_AURA_APPLIED" or event == "SPELL_AURA_REFRESH"))
                then
                    local splink = GetSpellLink(118);
                    SendChatMessage("{rt8} ".. splink .." on me, by this mage -> "..(sourceName or "(unknown)") .." ! {rt8}","SAY");
                end
            end
            -- End Mage ========================================================

            -- Monk ============================================================
            if (SayKarmaPrefs['MonkEnable'] == "yes") then
                -- Leg Sweep
                if ((spellId == 119381)
                    and (destName == SayKarmaEvent.playername)
                    and (event == "SPELL_AURA_APPLIED" or event == "SPELL_AURA_REFRESH"))
                then
                    local splink = GetSpellLink(119381);
                    SendChatMessage("{rt8} Stunned by this monk "..(sourceName or "(unknown)") .." with -> ".. splink .." ! {rt8}","SAY");
                end

                -- Paralysis
                if ((spellId == 115078)
                    and (destName == SayKarmaEvent.playername)
                    and (event == "SPELL_AURA_APPLIED" or event == "SPELL_AURA_REFRESH"))
                then
                    local splink = GetSpellLink(115078);
                    SendChatMessage("{rt8} Stunned by this monk "..(sourceName or "(unknown)") .." with -> ".. splink .." ! {rt8}","SAY");
                end

                -- Spear Hand Strike
                if ((spellId == 116705)
                    and (destName == SayKarmaEvent.playername)
                    and (event == "SPELL_AURA_APPLIED" or event == "SPELL_AURA_REFRESH"))
                then
                    local splink = GetSpellLink(116705);
                    SendChatMessage("{rt8} Silenced by this monk -> "..(sourceName or "(unknown)") .." with: ".. splink .." ! {rt8}","SAY");
                end

                -- Touch of Karma
                if ((spellId == 122470)
                    and (destName == SayKarmaEvent.playername)
                    and (event == "SPELL_AURA_APPLIED" or event == "SPELL_AURA_REFRESH"))
                then
                    local splink = GetSpellLink(122470);
                    SendChatMessage("{rt8} " .. splink .. " on me (10s). Stop dps this monk -> "..(sourceName or "(unknown)") .." ! {rt8}","SAY");
                end
            end
            -- End Monk ========================================================

            -- Paladin =========================================================
            if (SayKarmaPrefs['PaladinEnable'] == "yes") then
                -- Fist of Justice
                if ((spellId == 105593)
                    and (destName == SayKarmaEvent.playername)
                    and (event == "SPELL_AURA_APPLIED" or event == "SPELL_AURA_REFRESH"))
                then
                    local splink = GetSpellLink(105593);
                    SendChatMessage("{rt8} Stunned by this paladin "..(sourceName or "(unknown)") .." with -> ".. splink .." ! {rt8}","SAY");
                end

                -- Rebuke
                if ((spellId == 96231)
                    and (destName == SayKarmaEvent.playername)
                    and (event == "SPELL_AURA_APPLIED" or event == "SPELL_AURA_REFRESH"))
                then
                    local splink = GetSpellLink(96231);
                    SendChatMessage("{rt8} Silenced by this paladin -> "..(sourceName or "(unknown)") .." with: ".. splink .." ! {rt8}","SAY");
                end

                -- Repentance
                if ((spellId == 20066)
                    and (destName == SayKarmaEvent.playername)
                    and (event == "SPELL_AURA_APPLIED" or event == "SPELL_AURA_REFRESH"))
                then
                    local splink = GetSpellLink(20066);
                    SendChatMessage("{rt8} Stunned by this paladin -> "..(sourceName or "(unknown)") .." with: ".. splink .." ! {rt8}","SAY");
                end
            end
            -- End Paladin =====================================================

            -- Priest ==========================================================
            if (SayKarmaPrefs['PriestEnable'] == "yes") then
                -- Dominate Mind
                if ((spellId == 605)
                    and (destName == SayKarmaEvent.playername)
                    and (event == "SPELL_AURA_APPLIED" or event == "SPELL_AURA_REFRESH"))
                then
                    local splink = GetSpellLink(605);
                    SendChatMessage("{rt8} ".. splink .." on me, cc this priest -> "..(sourceName or "(unknown)") .." ! {rt8}","SAY");
                end
                
                -- Holy Word: Chastise
                if ((spellId == 88625)
                    and (destName == SayKarmaEvent.playername)
                    and (event == "SPELL_AURA_APPLIED" or event == "SPELL_AURA_REFRESH"))
                then
                    local splink = GetSpellLink(88625);
                    SendChatMessage("{rt8} Stunned by this priest -> "..(sourceName or "(unknown)") .." with: ".. splink .." ! {rt8}","SAY");
                end
                
                -- Psychic Horror
                if ((spellId == 64044)
                    and (destName == SayKarmaEvent.playername)
                    and (event == "SPELL_AURA_APPLIED" or event == "SPELL_AURA_REFRESH"))
                then
                    local splink = GetSpellLink(64044);
                    SendChatMessage("{rt8} Feared by this priest -> "..(sourceName or "(unknown)") .." with: ".. splink .." ! {rt8}","SAY");
                end

                -- Silence
                if ((spellId == 15487)
                    and (destName == SayKarmaEvent.playername)
                    and (event == "SPELL_AURA_APPLIED" or event == "SPELL_AURA_REFRESH"))
                then
                    local splink = GetSpellLink(15487);
                    SendChatMessage("{rt8} Silenced by this priest -> "..(sourceName or "(unknown)") .." with: ".. splink .." ! {rt8}","SAY");
                end
                
            end
            -- End Priest ======================================================

            -- Rogue ===========================================================
            if (SayKarmaPrefs['RogueEnable'] == "yes") then
                -- Blind
                if ((spellId == 2094)
                    and (destName == SayKarmaEvent.playername)
                    and (event == "SPELL_AURA_APPLIED" or event == "SPELL_AURA_REFRESH"))
                then
                    local splink = GetSpellLink(2094);
                    SendChatMessage("{rt8} " .. splink .. " on me, by this rogue -> "..(sourceName or "(unknown)") .." ! {rt8}","SAY");
                end

                -- Garrote
                if ((spellId == 1330)
                    and (destName == SayKarmaEvent.playername)
                    and (event == "SPELL_AURA_APPLIED" or event == "SPELL_AURA_REFRESH"))
                then
                    local splink = GetSpellLink(1330);
                    SendChatMessage("{rt8} Silenced by this rogue -> "..(sourceName or "(unknown)") .." with: ".. splink .." ! {rt8}","SAY");
                end

                -- kick
                if ((spellId == 2139)
                    and (destName == SayKarmaEvent.playername)
                    and (event == "SPELL_AURA_APPLIED" or event == "SPELL_AURA_REFRESH"))
                then
                    local splink = GetSpellLink(2139);
                    SendChatMessage("{rt8} Silenced by this rogue -> "..(sourceName or "(unknown)") .." with: ".. splink .." ! {rt8}","SAY");
                end

                -- Sap
                if ((spellId == 6770)
                    and (destName == SayKarmaEvent.playername)
                    and (event == "SPELL_AURA_APPLIED" or event == "SPELL_AURA_REFRESH"))
                then
                    local splink = GetSpellLink(6770);
                    SendChatMessage("{rt8} Sapped, by this rogue -> "..(sourceName or "(unknown)") .." ! {rt8}","SAY");
                end
            end
            -- End Rogue =======================================================

            -- Shaman ==========================================================
            if (SayKarmaPrefs['ShamanEnable'] == "yes") then
                -- Hex
                if ((spellId == 51514)
                    and (destName == SayKarmaEvent.playername)
                    and (event == "SPELL_AURA_APPLIED" or event == "SPELL_AURA_REFRESH"))
                then
                    local splink = GetSpellLink(51514);
                    SendChatMessage("{rt8} ".. splink .." on me, by this shaman -> "..(sourceName or "(unknown)") .." ! {rt8}","SAY");
                end

                -- Wind Shear
                if ((spellId == 57994)
                    and (destName == SayKarmaEvent.playername)
                    and (event == "SPELL_AURA_APPLIED" or event == "SPELL_AURA_REFRESH"))
                then
                    local splink = GetSpellLink(57994);
                    SendChatMessage("{rt8} Silenced by this shaman -> "..(sourceName or "(unknown)") .." with: ".. splink .." ! {rt8}","SAY");
                end
            end
            -- End Shaman ======================================================

            -- Warlock =========================================================
            if (SayKarmaPrefs['WarlockEnable'] == "yes") then
                -- Mesmerize
                if ((spellId == 115268)
                    and (destName == SayKarmaEvent.playername)
                    and (event == "SPELL_AURA_APPLIED" or event == "SPELL_AURA_REFRESH"))
                then
                    local splink = GetSpellLink(115268);
                    SendChatMessage("{rt8} Seduced, cc that succube asap ".. splink .." ! {rt8}","SAY");
                end

                -- Seduction
                if ((spellId == 6358)
                    and (destName == SayKarmaEvent.playername)
                    and (event == "SPELL_AURA_APPLIED" or event == "SPELL_AURA_REFRESH"))
                then
                    local splink = GetSpellLink(6358);
                    SendChatMessage("{rt8} Seduced, cc that succube asap ".. splink .." ! {rt8}","SAY");
                end
            end
            -- End Warlock =====================================================

            -- Warrior =========================================================
            if (SayKarmaPrefs['WarriorEnable'] == "yes") then
                -- Pummel
                if ((spellId == 6552)
                    and (destName == SayKarmaEvent.playername)
                    and (event == "SPELL_AURA_APPLIED" or event == "SPELL_AURA_REFRESH"))
                then
                    local splink = GetSpellLink(6552);
                    SendChatMessage("{rt8} Silenced by this war -> "..(sourceName or "(unknown)") .." with: ".. splink .." ! {rt8}","SAY");
                end

                -- Shockwave
                if ((spellId == 132168) -- or ((spellId == 46968)
                    and (destName == SayKarmaEvent.playername)
                    and (event == "SPELL_AURA_APPLIED" or event == "SPELL_AURA_REFRESH"))
                then
                    local splink = GetSpellLink(132168);
                    SendChatMessage("{rt8} Stunned by this war "..(sourceName or "(unknown)") .." with -> ".. splink .." ! {rt8}","SAY");
                end

                -- Storm Bolt
                if ((spellId == 107570)
                    and (destName == SayKarmaEvent.playername)
                    and (event == "SPELL_AURA_APPLIED" or event == "SPELL_AURA_REFRESH"))
                then
                    local splink = GetSpellLink(107570);
                    SendChatMessage("{rt8} Stunned by this war "..(sourceName or "(unknown)") .." with -> ".. splink .." ! {rt8}","SAY");
                end
            end
            -- End Warrior =====================================================

        end -- if (SayKarmaPrefs['SayKarmaEnable'] == "yes") then
    end -- function(_,_,_,event, _,_,sourceName, _,_,_,destName, _,_,spellId)
); -- SayKarmaEvent:SetScript(

SayKarmaEvent:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED");
